import * as Vue from 'vue';
import { warn } from './util';
export function collectDataFromConstructor(vm, Component) {
    Component.prototype._init = function () {
        var _this = this;
        Object.getOwnPropertyNames(vm).forEach(function (key) {
            Object.defineProperty(_this, key, {
                get: function () { return vm[key]; },
                set: function (value) { return vm[key] = value; }
            });
        });
    };
    var data = new Component();
    var plainData = {};
    Object.keys(data).forEach(function (key) {
        if (data[key] !== undefined) {
            plainData[key] = data[key];
        }
    });
    if (process.env.NODE_ENV !== 'production') {
        if (!(Component.prototype instanceof Vue) && Object.keys(plainData).length > 0) {
            warn('Component class must inherit Vue or its descendant class ' +
                'when class property is used.');
        }
    }
    return plainData;
}
